import dds
import ddsutil
import std_msgs/msg/Header_.std_msgs.msg.dds_
import struct

class WrenchStamped___TypeSupport(dds.TypeSupport):

    _typename = 'geometry_msgs::msg::dds_::WrenchStamped_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Vector3_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member></Struct><Struct name="Wrench_"><Member name="force_"><Type name="Vector3_"/></Member><Member name="torque_"><Type name="Vector3_"/></Member></Struct></Module></Module></Module><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="WrenchStamped_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="wrench_"><Type name="Wrench_"/></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(WrenchStamped___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(WrenchStamped_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, WrenchStamped_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = WrenchStamped_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class WrenchStamped_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return WrenchStamped___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs/msg/Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def wrench_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Wrench_ value
        @rtype: Wrench_
        '''
        return self._wrench__

    _wrench__checker = ddsutil._class_checker(Wrench_)
    @wrench_.setter
    def wrench_(self, value):
        self._wrench__checker(value)
        self._wrench__ = value

    _member_attributes = ('header_', 'wrench_')

    def __init__(self, **kwargs):
        ''' Create a WrenchStamped_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()
        self.wrench_ = Wrench_()
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if WrenchStamped_._packing_fmt is not None:
            return WrenchStamped_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs/msg/Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += ddsutil._align(fmt, Wrench_._get_packing_fmt())

        WrenchStamped_._packing_fmt = ddsutil._pad_fmt(fmt)
        return WrenchStamped_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.wrench_ = Wrench_()._deserialize(data)
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.extend(self.wrench_._get_packing_args())
        return args

